#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Aug  1 22:54:46 2019

@author: Anne-Cécile GAY
"""

###############################################################################
#                         INTERFACE GRAPHIQUE                                 #       
###############################################################################

current_source = ColumnDataSource()
current_source_select_word = ColumnDataSource()

  
def update_anexplo(statut):
    liste_note          = dict_statut_note[statut]
    current_df          = NLP_fct.fct_df_filtre_nps(comments,APP_GRADE,liste_note)

    # Nombre de retours
    nb_lignes_tot = current_df.shape[0]
    # Nombre de retours avec verbatims renseignés
    nb_lignes_vbt = current_df[current_df[APP_VAR].notnull()].shape[0]
    # Nombre de mots moyen par commentaire (si commentaire renseigné)
    nb_mots = int(round(current_df[current_df[APP_VAR].notnull()]['VbtTokenNosw'].apply(lambda x : len(x)).mean()))
       
    # Mots les plus fréquents
    current_mostfreq    = NLP_fct.fct_df_mots_freq(current_df,'VbtTokenNosw', 15)   
    
    # Eléménts graphiques dépendants du statut du client
    div_nb_retours.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=50%>
        <tr>
        </tr>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color=white>
                        <strong>
                            RETOURS <br>
                        </strong>
                    </FONT>                
                    <FONT size = 7 color=white> 
                        <strong >
                           {: .0f} <br>
                        </strong>
                    </FONT>
                    <FONT size = 2 color=white>
                        <strong >
                            CLIENTS
                        </strong>
                    </FONT>    
                </div>
            </td>
        </tr>
        <tr>
        </tr>
    </table>
    """.format(nb_lignes_tot)
  
    div_nb_vbt.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=50%>
        <tr>
        </tr>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color=white>
                        <strong>
                            DONT <br>
                        </strong>
                    </FONT>                
                    <FONT size = 7 color=white> 
                        <strong >
                           {}<br>
                        </strong>
                    </FONT>
                    <FONT size = 2 color=white>
                        <strong >
                            AVEC VERBATIMS
                        </strong>
                    </FONT>    
                </div>
            </td>
        </tr>
        <tr>
        </tr>
    </table>
    """.format(nb_lignes_vbt)    

    div_nb_mots.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=50%>
        <tr>
        </tr>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color=white>
                        <strong>
                            NOMBRE DE MOTS <br>
                        </strong>
                    </FONT>                
                    <FONT size = 7 color=white> 
                        <strong >
                           {}<br>
                        </strong>
                    </FONT>
                    <FONT size = 2 color=white>
                        <strong >
                            mots / commentaire
                        </strong>
                    </FONT>    
                </div>
            </td>
        </tr>
        <tr>
        </tr>
    </table>
    """.format(nb_mots)   
    
    if statut == 'Tous' :
        div_mots_freq.text = """
            <table style="border:1px solid white;" BGCOLOR=#0277bd width=200%>
                <tr>
                </tr>
                <tr>
                    <td>
                        <div align=center>                
                            <FONT size = 2 color=white>
                                <strong>
                                    mots les plus fréquents du corpus <br>
                                </strong>
                            </FONT>                   
                        </div>
                    </td>
                </tr>
                <tr>
                </tr>
            </table>
            """
    else :
        div_mots_freq.text = """
            <table style="border:1px solid white;" BGCOLOR=#0277bd width=200%>
                <tr>
                </tr>
                <tr>
                    <td>
                        <div align=center>                
                            <FONT size = 2 color=white>
                                <strong>
                                    mots les plus fréquents des clients {} <br>
                                </strong>
                            </FONT>                
                        </div>
                    </td>
                </tr>
                <tr>
                </tr>
            </table>
            """.format(statut)
            
    p_mots_freq.x_range.factors = current_mostfreq['word'].tolist()

    current_source.data = current_mostfreq.to_dict("list")
    
def update_anexplo_select_bar_word(choix) : 
    selected_word = current_source.data['word'][choix[0]]
    print('mot sélectionné : ')
    print(selected_word)
    df_extract_comments_word = NLP_fct.fct_filtre_word(comments_vbt,selected_word)
    print(df_extract_comments_word.head(5))

    df_extract_comments_word.reset_index()
    df_extract_comments_word['vbt'] = df_extract_comments_word[APP_VAR]
    current_source_select_word.data = {
            'commentaire'      : df_extract_comments_word.vbt,
            'index'            : df_extract_comments_word.index
        }   
    
    # Champs texte libellé tableau
    div_anexplo_extractword.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=200%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            extrait verbatims contenant le mot {}  <br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """.format(selected_word)
    
    
    
######################
# FONCTIONS CALLBACK #
######################
    
def callback_anexplo_selectnps(attr,old, new):
    update_anexplo(statut=liste_statuts[new])
    
def callback_anexplo_select_bar_word(attr, old, new):
    update_anexplo_select_bar_word(new)   
    

######################
#      WIDGETS       # 
######################  
    
# WIDGET TEXTES
div_anexplo_choixclient = Div()
div_anexplo_choixclient.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=50%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            sélection clients <br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """

    
    
# WIDGET VBAR
p_mots_freq = plotting.figure(x_range=bokeh.models.FactorRange(),
                    plot_height=300,tools="tap")            
p_mots_freq.vbar(x='word', top='occurrence', width=0.9, legend=None,fill_color='#004C8C', source=current_source)
p_mots_freq.xaxis.major_label_orientation = 1    
p_mots_freq_tooltips = """
    <div>
        <h3> <font color='#0277bd'> Mot : @word </font></h3>
        <div> <strong> Fréquence :  </strong> @occurrence </div>      
    </div>
"""
p_mots_freq.add_tools(HoverTool(tooltips=p_mots_freq_tooltips))
p_mots_freq.axis.visible = True
p_mots_freq.grid.visible = False


# WIDGET DATATABLE 
columns = [
    TableColumn(field="word", title="Mot"),
    TableColumn(field="occurrence", title="Fréquence")
    ]
data_table = DataTable(source=current_source, columns=columns, width=300)    

# WIDGET CHECKBOX note NPS
widget_anexplo_radiogroup_nps = RadioGroup(labels=liste_statuts, active = 1)    
widget_anexplo_radiogroup_nps.on_change('active',callback_anexplo_selectnps)

# WIDGET DATA TABLE SELECTION MOTS
current_source.selected.on_change('indices', callback_anexplo_select_bar_word) 
columns = [
    TableColumn(field="commentaire", title="Commentaire"),
    TableColumn(field="index", title="Index")
    ]
data_table_select_bar_word = DataTable(source=current_source_select_word, columns=columns, width=600,height=200,fit_columns=False,index_width=10)    
 



######################
#      LAYOUT        # 
######################

div_nb_retours          = Div()
div_nb_vbt              = Div()
div_nb_mots             = Div()
div_mots_freq           = Div()
div_mot_select          = Div()
div_anexplo_extractword = Div()

layout_widget_anexplo   = column(div_anexplo_choixclient,widget_anexplo_radiogroup_nps)
layout_descr_anexplo    = column(div_nb_retours,div_nb_vbt,div_nb_mots)
layout_motsfreq_anexplo = column(div_mots_freq,p_mots_freq,column(div_anexplo_extractword,data_table_select_bar_word))

tab_anexplo_layout = row(layout_widget_anexplo,layout_descr_anexplo,layout_motsfreq_anexplo)

######################
#   INITIALISATION   # 
######################

update_anexplo(statut=liste_statuts[widget_anexplo_radiogroup_nps.active])
