#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Sep 19 22:15:46 2019

@author: Anne-Cécile GAY
"""

##############################################################################
#                                PARAMETRES                                   #                                       
###############################################################################


###############################################################################
#                             PRE TRAITEMENTS                                 #       
###############################################################################

# NOMBRE DE MOTS DU COMMENTAIRE #
comments_vbt['nb_words']   = comments_vbt['VbtTokenNosw'].apply(lambda x : len(x))
comments_vbt['nb_words']   = comments_vbt['nb_words'].apply(lambda x : float(x))


# NOTE MOYENNE EN FONCTION DU NOMBRE DE MOTS #
stats_nbwords = comments_vbt['nb_words'].describe(percentiles=[.1,.25,.5,.75,.9]).transpose()

comments_vbt[comments_vbt['nb_words'].between(0, stats_nbwords['10%'])][APP_GRADE].mean()
comments_vbt[comments_vbt['nb_words'].between(stats_nbwords['10%'], stats_nbwords['25%'])][APP_GRADE].mean()
comments_vbt[comments_vbt['nb_words'].between(stats_nbwords['25%'], stats_nbwords['50%'])][APP_GRADE].mean()
comments_vbt[comments_vbt['nb_words'].between(stats_nbwords['50%'], stats_nbwords['75%'])][APP_GRADE].mean()
comments_vbt[comments_vbt['nb_words'].between(stats_nbwords['75%'], stats_nbwords['max'])][APP_GRADE].mean()

# NOMBRE DE MOTS EN FONCTION DU STATUT DU CLIENT
def fct_nb_words_statut(df,dict,statut) :
    nb_words_statut = df.loc[df[APP_GRADE].isin(dict[statut]),'nb_words'].mean()
    return(nb_words_statut)

statut_list = list(dict_statut_note.keys())
statut_list.remove('Tous')  
df_nbwords_statut = pd.DataFrame(index=statut_list)
df_nbwords_statut['statut'] = statut_list

    
for statut in statut_list :      
    df_nbwords_statut.loc[statut,'mean_nb_words'] = fct_nb_words_statut(comments_vbt,dict_statut_note,statut)
    
# SOURCE NOMBRE DE MOTS EN FONCTION DU STATUT DU CLIENT
current_source_anfeelsent = ColumnDataSource()    
current_source_anfeelsent.data = {
        'statut'        : df_nbwords_statut.statut,
        'mean_nb_words' : df_nbwords_statut.mean_nb_words,
        'color'         : [dict_statut_color[x] for x in statut_list]
    }



# NOMBRE DE POINTS D'EXCLAMATION #
comments_vbt['nb_exclam'] = comments_vbt[APP_VAR].apply(lambda text : FreqDist(str(text))['!'])
comments_vbt.loc[comments_vbt['nb_exclam']==0,'nb_exclam_f']  ='sans !'
comments_vbt.loc[comments_vbt['nb_exclam']>0,'nb_exclam_f']   ='avec !'

df_nb_exclam = pd.DataFrame(comments_vbt.groupby('nb_exclam_f')[APP_GRADE].mean())
df_nb_exclam.reset_index(inplace=True)

current_source_nb_exclam = ColumnDataSource()    
current_source_nb_exclam.data = {
        'nb_exclam'     : df_nb_exclam.nb_exclam_f,
        'mean_note'     : df_nb_exclam.Recommandation,
        'color'         : ['#35B7A8','#FDE724']
    }


# NOMBRE DE POINTS D'INTERROGATION #
comments_vbt['nb_interrog'] = comments_vbt[APP_VAR].apply(lambda text : FreqDist(str(text))['?'])
comments_vbt.loc[comments_vbt['nb_interrog']==0,'nb_interrog_f']  ='sans ?'
comments_vbt.loc[comments_vbt['nb_interrog']>0,'nb_interrog_f']   ='avec ?'

df_nb_interrog = pd.DataFrame(comments_vbt.groupby('nb_interrog_f')[APP_GRADE].mean())
df_nb_interrog.reset_index(inplace=True)

current_source_nb_interrog = ColumnDataSource()    
current_source_nb_interrog.data = {
        'nb_interrog'   : df_nb_interrog.nb_interrog_f,
        'mean_note'     : df_nb_interrog.Recommandation,
        'color'         : ['#35B7A8','#FDE724']
    }

######################
#       TEXTES       #  
######################
    
div_anfeelsent_nbwords = Div()
div_anfeelsent_nbwords.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=210%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            nombre moyen de mots par commentaire  <br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """
    
div_anfeelsent_pointexclam = Div()
div_anfeelsent_pointexclam.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=210%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            note moyenne selon présence points d'exclamation<br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """
    
div_anfeelsent_pointinterrog = Div()
div_anfeelsent_pointinterrog.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=210%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            note moyenne selon présence points d'interrogation<br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """
    
    

######################
#     GRAPHIQUES     #
######################

# NOMBRE DE MOTS #
p_anfeelsent_nbwords = plotting.figure(y_range=statut_list, plot_height=200)
p_anfeelsent_nbwords.segment(0, 'statut', 'mean_nb_words', 'statut', line_width=15, line_color='color',source=current_source_anfeelsent)
p_anfeelsent_nbwords.circle('mean_nb_words', 'statut', size=15, fill_color='color', line_color='color', line_width=3,source=current_source_anfeelsent)
p_anfeelsent_nbwords.grid.visible = False
p_anfeelsent_nbwords_tooltips = """
    <div>
        <tr>
        </tr>
        <h3> <font color='#0277bd'> @statut </font></h3>
        <div><strong>Nb moyen de mots : </strong>@mean_nb_words{(0)}</div>  
        <tr>
        </tr>
    </div>
"""
p_anfeelsent_nbwords.add_tools(HoverTool(tooltips=p_anfeelsent_nbwords_tooltips))


# NOMBRE DE POINTS D'EXCLAMATION #
p_anfeelsent_nb_exclam = plotting.figure(x_range=['sans !','avec !'],plot_height=250)            
p_anfeelsent_nb_exclam.vbar(x='nb_exclam', top='mean_note', width=0.3, legend=None, source=current_source_nb_exclam, fill_color='#004C8C', line_color='#004C8C') 
p_anfeelsent_nb_exclam_tooltips = """
    <div>
        <tr>
        </tr>
        <h3> <font color='0277bd'> commentaires @nb_exclam </font></h3>
        <div><strong>Note moyenne : </strong>@mean_note{(0.0)}</div>   
        <tr>
        </tr>
    </div>
"""
p_anfeelsent_nb_exclam.add_tools(HoverTool(tooltips=p_anfeelsent_nb_exclam_tooltips))


# NOMBRE DE POINTS D'INTERROGATION #
p_anfeelsent_nb_interrog = plotting.figure(x_range=['sans ?','avec ?'],plot_height=250)            
p_anfeelsent_nb_interrog.vbar(x='nb_interrog', top='mean_note', width=0.3, legend=None, source=current_source_nb_interrog, fill_color='#004C8C', line_color='#004C8C') 
p_anfeelsent_nb_interrog_tooltips = """
    <div>
        <tr>
        </tr>
        <h3> <font color='0277bd'> commentaires @nb_interrog </font></h3>
        <div><strong>Note moyenne : </strong>@mean_note{(0.0)}</div>   
        <tr>
        </tr>
    </div>
"""
p_anfeelsent_nb_interrog.add_tools(HoverTool(tooltips=p_anfeelsent_nb_interrog_tooltips))




######################
#      LAYOUT        # 
######################

layout_nbwords = row(Spacer(width=300, height=200,sizing_mode='scale_width'),column(div_anfeelsent_nbwords,p_anfeelsent_nbwords))
layout_ponct   = row(column(div_anfeelsent_pointexclam,p_anfeelsent_nb_exclam),Spacer(width=100, height=400,sizing_mode='scale_width'),column(div_anfeelsent_pointinterrog,p_anfeelsent_nb_interrog))
tab_anfeelsent_layout = column(layout_nbwords,Spacer(width=100, height=40,sizing_mode='scale_width'),layout_ponct)


