#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Feb 20 15:30:30 2019

@author: Anne-Cécile GAY
"""



###############################################################################
#                                PARAMETRES                                   #                                 #       
###############################################################################

# Nombre de commentaires à afficher quand sélection barre
selectbar_nb_comment = 100


###############################################################################
#                             PRE TRAITEMENTS                                 #       
###############################################################################

#copy(os.path.join(APP_DIR, 'model/'+str(APP_MODEL)+'.html'), os.path.join(APP_DIR, 'static/'+str(APP_MODEL)+'.html'))

# CHARGEMENT MODÈLE LDA #
print('********** Chargement de la modélisation LDA... **********')
temp_file = datapath(os.path.join(APP_DIR_PARENT, 'model/'+str(APP_MODEL)+'.gensim'))
mylda = gensim.models.ldamodel.LdaModel.load(temp_file)
pathdict = datapath(os.path.join(APP_DIR_PARENT, 'dictionary.gensim'))
mydict = gensim.corpora.Dictionary.load(pathdict)
print('********** modèle LDA chargé ! **********')

# DETERMINATION DES TOPICS ET PROBAS ASSOCIÉES #
print('********** Application du modèle sur chaque verbatim... **********')
comments_vbt['proba_topic'] = comments_vbt['VbtTokenNosw'].apply(lambda text : NLP_fct.proba_topic(str(text),mylda,mydict))


# DETERMINATION DU TOPIC PRINCIPAL #
# Ajout d'une colonne dans le dataframe avec topic max et proba
comments_vbt['max_proba_topic']     = comments_vbt['VbtTokenNosw'].apply(lambda text : NLP_fct.max_proba_topic(str(text),mylda,mydict))
comments_vbt['main_topic']          = comments_vbt['max_proba_topic'].apply(lambda mytuple:mytuple[0])
comments_vbt['proba_main_topic']    = comments_vbt['max_proba_topic'].apply(lambda mytuple:mytuple[1])


# MATRICE DES INDIVIDUS*TOPICS
comments_vbt['nb_topics']   = comments_vbt['proba_topic'].apply(lambda mytuple:len(mytuple))
pb_topic_mat = pd.np.zeros((len(comments_vbt),comments_vbt["nb_topics"].max()))
for i, pb in enumerate(comments_vbt["proba_topic"]):
    np.put(pb_topic_mat[i, :], *zip(*pb))
df_proba_topics = pd.DataFrame(pb_topic_mat)
comments_temp = comments_vbt.reset_index()
df_proba_topics[APP_GRADE]   = comments_temp[APP_GRADE]
df_proba_topics['index']            = comments_temp['index']
df_proba_topics.set_index('index',inplace=True)

# NOTE MOYENNE SI VERBATIM RENSEIGNE
note_moy_vbt = np.mean(comments_vbt[APP_GRADE])
#note_moy_vbt = comments_vbt.loc[comments_vbt['proba_main_topic']>=0.2][APP_GRADE].mean()


###############################################################################
#                         INTERFACE GRAPHIQUE                                 #       
###############################################################################

######################
#  FONCTIONS UPDATE  #
######################

current_source_antopics = ColumnDataSource()    
current_source_selectbar = ColumnDataSource()

def update_antopics(statut) :

    # Filtre sur notes
    liste_note = dict_statut_note[statut]
    current_df_antopics = NLP_fct.fct_df_filtre_nps(comments_vbt,APP_GRADE,liste_note) 
    current_dfprobatopics_antopics = NLP_fct.fct_df_filtre_nps(df_proba_topics,APP_GRADE,liste_note)
    
    #note_moy_vbt = np.mean(current_dfprobatopics_antopics[APP_GRADE])
     
    # Liste des topics
    list_topics = current_dfprobatopics_antopics.drop([APP_GRADE], axis=1).columns.values.tolist()
    metadata_topics = pd.DataFrame(index=list_topics)
    metadata_topics['topics'] = list_topics
    metadata_topics['topics'] = metadata_topics['topics'].apply(lambda myint : str(myint))  
    
    # Création de metadata topics
    for topic_current in list_topics :
        #topic_mean_note = current_dfprobatopics_antopics.loc[current_dfprobatopics_antopics[topic_current]>=0.5][APP_GRADE].mean()
        topic_mean_note = current_df_antopics.loc[current_df_antopics['main_topic']==topic_current][APP_GRADE].mean()
        metadata_topics.loc[topic_current,'mean_note'] = topic_mean_note
        
        # Présence de ce topic dans le corpus
        topic_repartition = current_dfprobatopics_antopics[topic_current].mean()
        metadata_topics.loc[topic_current,'repartition']=topic_repartition 
        
        # Estimation du nombre de verbatims concernés par le topic current
        topic_estim_nb_vbt_all = len(current_dfprobatopics_antopics)
        print('nombre total verbatims' + str(topic_estim_nb_vbt_all))
        topic_estim_nb_vbt = current_dfprobatopics_antopics[topic_current].sum()
        metadata_topics.loc[topic_current,'estim_nb_vbt']=topic_estim_nb_vbt
        print('*****************************')
        print('* PRINT topic_estim_nb_vbt *')
        print(topic_estim_nb_vbt)
        
        
        print('*****************************')
        print('* PRINT current_dfprobatopics_antopics *')
        print(current_dfprobatopics_antopics.head())
        print(list(current_dfprobatopics_antopics))
        
    metadata_topics['ecart_note_moy_vbt'] = metadata_topics['mean_note']-note_moy_vbt
    metadata_topics.loc[metadata_topics['ecart_note_moy_vbt']>=0, 'ecart_note_moy_vbt_sign']='+'
    metadata_topics.loc[metadata_topics['ecart_note_moy_vbt']<0,  'ecart_note_moy_vbt_sign']='-'    
    
    # Attributs pour graphiques
    p_nps_maintopic.x_range.factors = [str(i) for i in list_topics]
    p_maintopic_h.y_range.factors = [str(i) for i in list_topics]
    
    current_source_antopics.data = {
            'topic'                 : metadata_topics.topics,
            'repartition'           : metadata_topics.repartition,
            'estim_nb_vbt'          : metadata_topics.estim_nb_vbt,
            'note_moyenne'          : metadata_topics.mean_note,
            'ecart_note_moy'        : metadata_topics.ecart_note_moy_vbt,
            'ecart_note_moy_sign'   : metadata_topics.ecart_note_moy_vbt_sign
        }



def update_select_bar(item) :
    selected_topic = current_source_antopics.data['topic'][item]
    df_proba_topics.sort_values(by = int(selected_topic),ascending = False, inplace=True)
    df_extract_comments_topic = pd.concat([comments_vbt, df_proba_topics.head(selectbar_nb_comment)], axis=1,join='inner')
    df_extract_comments_topic.reset_index()
    df_extract_comments_topic['vbt'] = df_extract_comments_topic[APP_VAR]
    current_source_selectbar.data = {
            'index'            : df_extract_comments_topic.index,
            'commentaire'      : df_extract_comments_topic.vbt
        }
    
    # Champs texte libellé tableau
    div_antopics_extracttopic.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=200%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            extrait verbatims topic {}  <br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """.format(item[0])
    
    
    
    

######################
#     GRAPHIQUES     #
######################

# GRAPHIQUE : OCCURENCES PAR TOPIC PRINCIPAL #
p_maintopic_h = plotting.figure(y_range=bokeh.models.FactorRange(), plot_width=400, plot_height=520, toolbar_location='left',tools="tap")
p_maintopic_h.hbar(y='topic', right='repartition', height=0.6,source=current_source_antopics, fill_color='#004C8C')
                   
p_maintopic_h.grid.visible = False
p_maintopic_h.outline_line_color = None
p_maintopic_h_tooltips = """
    <div>
        <h3> <font color='#0277bd'> Topic @topic </font></h3>
        <div> <strong> Part du corpus concerné :  </strong>@repartition{0.0%}</div> 
        <div><strong>Note moyenne : </strong>@note_moyenne{(0.0)}</div>    
        <div><strong>Estimation nb verbatim concernés : </strong>@estim_nb_vbt{(0)}</div>
    </div>
"""
p_maintopic_h.add_tools(HoverTool(tooltips=p_maintopic_h_tooltips))
p_maintopic_h.xaxis.formatter = NumeralTickFormatter(format='0 %')



# GRAPHIQUE : NOTE MOYENNE PAR TOPIC PRINCIPAL #
p_nps_maintopic = plotting.figure(x_range = bokeh.models.FactorRange(),plot_height=250, tools="tap")            
#p_nps_maintopic.vbar(x='topic', top='ecart_note_moy', width=0.9, legend=None, source=current_source_antopics,color='#58a5f0')
                     
p_nps_maintopic.vbar(x='topic', top='ecart_note_moy', width=0.9, legend=None, source=current_source_antopics,fill_color=factor_cmap('ecart_note_moy_sign',palette=["#00FF00", "#FF6F00"],factors=['+','-']))

                                                                                                                                                     
#p_nps_maintopic.vbar(x='topic', top='ecart_note_moy', width=0.9, legend=None, source=current_source_antopics,color=('ecart_note_moy' > 0).map({True: 'green',False: 'red'}))
                     
                                        
                     
                     
p_nps_maintopic.xaxis.major_label_orientation = 1
p_nps_maintopic.grid.visible = False
p_nps_maintopic.outline_line_color = None
p_nps_maintopic_tooltips = """
    <div>
        <h3> <font color='#0277bd'> Topic @topic </font></h3>
        <div> <strong> Ecart à la note moyenne :  </strong>@ecart_note_moy{0.0}</div>     
    </div>
"""
p_nps_maintopic.add_tools(HoverTool(tooltips=p_nps_maintopic_tooltips))


######################
# FONCTIONS CALLBACK #
######################

def callback_antopics_selectnps(attr,old, new):
    update_antopics(statut=liste_statuts[new])
 
def callback_antopics_selectbar(attr, old, new):
    update_select_bar(new)   
    
 
    
######################
#      WIDGETS       # 
######################   

# WIDGET CHECKBOX note NPS
widget_antopics_radiogroup_nps = RadioGroup(labels=liste_statuts, active = 1)    
widget_antopics_radiogroup_nps.on_change('active',callback_antopics_selectnps)

# WIDGET TEXTES
div_antopics_extracttopic = Div()

div_antopics_choixclient = Div()
div_antopics_choixclient.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=50%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            sélection clients  <br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """
    
div_antopics_ecartnotemoy = Div()
div_antopics_ecartnotemoy.text = """
    <table style="border:1px solid white;" BGCOLOR=#0277bd width=200%>
        <tr>
            <td>
                <div align=center>                
                    <FONT size = 2 color='white'>
                        <strong>
                            écart à la note moyenne <br>
                        </strong>
                    </FONT>                  
                </div>
            </td>
        </tr>
    </table>
    """

div_antopics_repartition_topics = Div()
div_antopics_repartition_topics.text = """
            <table style="border:1px solid white;" BGCOLOR=#0277bd width=139%>
                <tr>
                </tr>
                <tr>
                    <td>
                        <div align=center>                
                            <FONT size = 2 color=white>
                                <strong>
                                    répartition des thématiques <br>
                                </strong>
                            </FONT>                
                        </div>
                    </td>
                </tr>
                <tr>
                </tr>
            </table>
            """
            
# WIDGET DATATABLE - sélection barre
current_source_antopics.selected.on_change('indices', callback_antopics_selectbar)    

columns = [
    TableColumn(field="commentaire", title="Commentaire"),
    TableColumn(field="index", title="Index")
    ]
widget_antopics_data_table_selectbar = DataTable(source=current_source_selectbar, columns=columns, width=560,height=180)  



######################
#      LAYOUT        # 
######################

layout_widget_antopics      = column(div_antopics_choixclient,widget_antopics_radiogroup_nps)
layout_antopics_widget_plot = row(column(div_antopics_repartition_topics,p_maintopic_h),Spacer(width=50, height=400,sizing_mode='scale_width'),column(div_antopics_ecartnotemoy,p_nps_maintopic,Spacer(width=600, height=50,sizing_mode='scale_width'),column(div_antopics_extracttopic,widget_antopics_data_table_selectbar)))

tab_antopics_layout = row(layout_widget_antopics,layout_antopics_widget_plot)



######################
#   INITIALISATION   # 
######################
update_antopics(statut=liste_statuts[widget_antopics_radiogroup_nps.active])
